package ws;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Collections;
import java.util.Iterator;
import java.util.Set;
import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.jws.HandlerChain;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.namespace.QName;
import javax.xml.soap.AttachmentPart;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.transform.Source;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;


@Stateless()
@WebService( targetNamespace="http://localhost:8080/returnAttachService/returnAttach")
@HandlerChain( name = "returnAttach_handlerChain", file = "returnAttach_handler.xml")
@SOAPBinding(style=SOAPBinding.Style.RPC)
public class returnAttach implements SOAPHandler<SOAPMessageContext> {
    @Resource
    protected WebServiceContext wsContext;
    SOAPMessage message;
    /*
     * Web service operation
     */
    @WebMethod(operationName="dispartAttach")
    
    public SOAPMessage dispartAttach() {
        try {
            Iterator iterator = message.getAttachments();
            while (iterator.hasNext()) {
                AttachmentPart attached = (AttachmentPart) iterator.next();
                String id = attached.getContentId();
                String type = attached.getContentType();
                
                if (id.equalsIgnoreCase("text/plain")) {
                    Object content = attached.getContent();
                    System.out.println("Attachment contains:\n" + content);
                }
            }
        } catch(Exception ex){
            
            ex.printStackTrace();
        }
        return this.message;
    }

    public boolean handleMessage(SOAPMessageContext messageContext) {
        SOAPMessage msg = messageContext.getMessage();
               this.message =msg;
        return true;
    }
    public Set<QName> getHeaders() {
        return Collections.EMPTY_SET;
    }
    public boolean handleFault(SOAPMessageContext messageContext) {
        return true;
    }
    public void close(MessageContext context) {
    }

    
}
